package server

import (
	"fmt"
	"github.com/gin-gonic/gin"
	"net/http"
	"os"
	"os/signal"
	"syscall"
	"testing"
)

func TestHttpServer_InitServer(t *testing.T) {
	type fields struct {
		server *http.Server
		status bool
		engine *gin.Engine
	}
	tests := []struct {
		name   string
		fields fields
	}{
		// TODO: Add test cases.
	}
	for _, tt := range tests {
		t.Run(tt.name, func(t *testing.T) {
			s := &HttpServer{
				server: tt.fields.server,
				status: tt.fields.status,
				engine: tt.fields.engine,
			}
			s.Init()
		})
	}
}

func TestHttpServer_Start(t *testing.T) {
	type fields struct {
		server *http.Server
		status bool
		engine *gin.Engine
	}
	tests := []struct {
		name   string
		fields fields
	}{
		// TODO: Add test cases.
		{
			name: "0.0.0.0",
			fields: fields{
				server: nil,
				status: false,
				engine: nil,
			},
		},
	}
	for _, tt := range tests {
		t.Run(tt.name, func(t *testing.T) {
			s := &HttpServer{
				server: tt.fields.server,
				status: tt.fields.status,
				engine: tt.fields.engine,
			}
			s.initServer("0.0.0.0", 35541)
			s.Start()
			quit := make(chan os.Signal, 1)
			signal.Notify(quit, syscall.SIGINT, syscall.SIGTERM)
			<-quit
			fmt.Println("Shutting down server...")
		})
	}
}

func TestHttpServer_Stop(t *testing.T) {
	type fields struct {
		server *http.Server
		status bool
		engine *gin.Engine
	}
	tests := []struct {
		name   string
		fields fields
	}{
		// TODO: Add test cases.
	}
	for _, tt := range tests {
		t.Run(tt.name, func(t *testing.T) {
			s := &HttpServer{
				server: tt.fields.server,
				status: tt.fields.status,
				engine: tt.fields.engine,
			}
			s.Stop()
		})
	}
}

func TestHttpServer_register(t *testing.T) {
	type fields struct {
		server *http.Server
		status bool
		engine *gin.Engine
	}
	tests := []struct {
		name   string
		fields fields
	}{
		// TODO: Add test cases.
	}
	for _, tt := range tests {
		t.Run(tt.name, func(t *testing.T) {
			s := &HttpServer{
				server: tt.fields.server,
				status: tt.fields.status,
				engine: tt.fields.engine,
			}
			s.register()
		})
	}
}

func TestHttpServer_initServer(t *testing.T) {
	type fields struct {
		server *http.Server
		status bool
		engine *gin.Engine
	}
	type args struct {
		host string
		port int
	}
	tests := []struct {
		name   string
		fields fields
		args   args
	}{
		// TODO: Add test cases.
	}
	for _, tt := range tests {
		t.Run(tt.name, func(t *testing.T) {
			s := &HttpServer{
				server: tt.fields.server,
				status: tt.fields.status,
				engine: tt.fields.engine,
			}
			s.initServer(tt.args.host, tt.args.port)
		})
	}
}
