package http_handler

import (
	"acme-mana/src/acme"
	"acme-mana/src/conf"
	"acme-mana/src/server/model"
	"github.com/gin-gonic/gin"
	"log"
)

var CertHandlerInstance = &CertHandler{}

type CertHandler struct {
}

func (h *CertHandler) List(c *gin.Context) {
	log.Println("list cert")
	certs := conf.Config().Certs
	c.JSON(200, model.SuccessD(certs))
}

func (h *CertHandler) Get(c *gin.Context) {
	log.Println("get cert")
	name := c.Query("name")
	if name == "" {
		c.Error(model.NewAppError(500, "请输入名称"))
		return
	}
	cert, _ := conf.FindCert(name)
	c.JSON(200, model.SuccessD(cert))
}

func (h *CertHandler) Refresh(c *gin.Context) {
	log.Println("refresh cert")
	name := c.Query("name")
	if name == "" {
		c.Error(model.NewAppError(500, "请输入名称"))
		return
	}
	cert, _ := conf.FindCert(name)
	acme.Apply(cert)
	c.JSON(200, model.Success())
}
