package server

import (
	"acme-mana/src/common"
	socker_handler "acme-mana/src/server/socket_handler"
	"log"
	"net"
	"os"
)

type SocketServer struct {
}

func (s *SocketServer) InitSocketServer() {

}

func (s *SocketServer) Start() {
	go start()
}

func start() {
	log.Println("启动指令监听服务...")
	// 删除旧的 socket 文件
	if _, err := os.Stat(common.SocketFile); err == nil {
		err := os.Remove(common.SocketFile)
		if err != nil {
			log.Fatalf("无法删除Socket文件: %v\n", err)
		}
	}

	listener, err := net.Listen("unix", common.SocketFile)
	if err != nil {
		log.Fatalf("Failed to listen on socket: %v", err)
	}
	defer func(listener net.Listener) {
		err := listener.Close()
		if err != nil {
			log.Fatalf("无法关闭Socket文件监听: %v", err)
		}
	}(listener)

	for {
		log.Println("等待连接...")
		conn, err := listener.Accept()
		if err != nil {
			log.Printf("无法建立连接: %v", err)
			continue
		}

		go socker_handler.HandleConnection(conn)
	}
}
