package socket_handler

import (
	"acme-mana/src/common"
	"log"
	"net"
	"os"
)

func HandleConnection(conn net.Conn) {
	defer conn.Close()

	buf := make([]byte, 1024)
	n, err := conn.Read(buf)
	if err != nil {
		log.Printf("Failed to read command: %v", err)
		return
	}

	command := string(buf[:n])
	log.Printf("Received command: %s", command)

	// 在这里处理接收到的命令
	switch command {
	case "stop":
		onStop()
	default:
		onCommand(command)
	}
}

/*
收到命令
*/
func onCommand(command string) {

}

// 收到停止命令
func onStop() {
	log.Println("停止守护进程...")
	os.Remove(common.PidFile)
	log.Println("删除PID文件...")
	os.Remove(common.SocketFile)
	log.Println("删除Socket文件...")
	os.Exit(0)
}
